---
title: SMA Solar
description: Instructions on how to connect your SMA Solar Inverter to Home Assistant.
ha_category:
  - Energy
ha_iot_class: Local Polling
ha_release: 0.36
ha_codeowners:
  - '@kellerza'
ha_domain: sma
---

The `sma` sensor will poll a [SMA](http://www.sma-solar.com/) [(US)](https://www.sma-america.com/) solar inverter and present the values as sensors (or attributes of sensors) in Home Assistant.

This sensor uses the web interface and to use it, you have to be able to connect to the solar inverter from your favorite web browser.

## Configuration

To enable this sensor, add the following lines to your `configuration.yaml` file:

```yaml
# Example configuration.yaml entry (http)
sensor:
  - platform: sma
    host: IP_ADDRESS_OF_DEVICE
    password: YOUR_SMA_PASSWORD
    sensors:
      - current_consumption
      - total_consumption
      - pv_power
      - total_yield

# Example configuration.yaml entry (https)
sensor:
  - platform: sma
    host: IP_ADDRESS_OF_DEVICE
    ssl: true
    verify_ssl: false
    password: YOUR_SMA_PASSWORD
    sensors:
      - current_consumption
      - total_consumption
      - pv_power
      - total_yield
```

{% configuration %}
host:
  description: The IP address of the SMA WebConnect module.
  required: true
  type: string
ssl:
  description: Enables HTTPS if set to `true`, otherwise with `false` the platform run with HTTP.
  required: false
  default: false
  type: boolean
verify_ssl:
  description: Whether Home Assistant should verify the SSL certificate from the inverter. Self-signed certificates may require `false` for this sensor to operate properly.
  required: false
  default: true
  type: boolean
password:
  description: The password of the SMA WebConnect module.
  required: true
  type: string
group:
  description: The user group, which can be either `user` or `installer`.
  required: false
  default: user
  type: string
sensors:
  description: A list of sensors that will be added. Refer to the table in the Sensors section below. If not specified all the sensors in the library will be added.
  required: false
  default: All sensors
  type: list
custom:
  description: A dictionary of custom sensor key values and units.
  required: false
  type: map
  keys:
    key:
      description: The SMA sensor key.
      required: true
      type: string
    unit:
      description: Unit.
      required: true
      type: string
    factor:
      description: Factor.
      required: false
      default: 1
      type: float
    path:
      description: A custom JMESpath to extract the sensor value (typically not required, advanced use only).
      required: false
      type: string
{% endconfiguration %}

## Sensors

Sensors available in the library:

| name         | Unit | Description   |
|--------------|------|:-------------------------------------------|
| pv_power     | W    | Current power generated by the inverter.   |
| pv_gen_meter | kWh  | Total kWh generated to date.               |
| total_yield  | kWh  | Total power yield from a solar installation. |
| daily_yield  | Wh   | The solar plant's yield for today.         !
| current_consumption | W | Power that you are currently drawing, depending on your installation it can be a combination of the inverter and the grid. |
| total_consumption | kWh | Total power consumption. |
| grid_power_supplied | W | Power supplied. |
| grid_power_absorbed | W | Power absorbed. |
| grid_total_yield | kWh | Total power from the grid. |
| grid_total_absorbed | Wh | Total power supplied to the grid
| grid_power | W | Power supplied by the grid. |
| frequency  | Hz | Grid frequency. |
| voltage_l1 | V | Voltage for phase 1. |
| voltage_l2 | V | Voltage for phase 2. |
| voltage_l2 | V | Voltage for phase 3. |
| status     |  | Status of the solar plant. |

The SMA WebConnect module supports a wide variety of sensors, and not all these have been mapped in the `pysma` library. Custom sensors can be defined by using the `custom` section of the configuration. You will need: A sensor name (no spaces), the SMA sensor key and the unit.

Example:

```yaml
   custom:
      yesterday_consumption:
         key: '6400_00543A01'
         unit: kWh
         factor: 1000
```

Over time more sensors will be added as standard sensors to the [pysma library](https://github.com/kellerza/pysma/blob/master/pysma/__init__.py#L100). Feel free to submit additional sensors on that repository.
